/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import javachan.IGraphicsDriver.IImage;

/**
 *
 * @author matt
 */
public class GameStateNPChar {
    public NPCCharacter[] chars = new NPCCharacter[100];

    public static class NPCCharacter {
        public boolean Exists=false;
        public double X, Y, OX, OY, LastTimeIkachanAnnoyedMe = 0;
        public int Type, CollisionType,Status, EventID;//collisiontype:0:NULL 1:BLOCK 2:ENEMY 3:EVENT

        public NPCCharacter() {
        }

        public Rect GetRectangle() {
            return new Rect((int) (X * 16), (int) (Y * 16), 16, 16);
        }
        public String[] NpcImg={
        "Pbm/Hari.pbm","Pbm/Isogin.pbm","Pbm/Kani.pbm","Pbm/Sleep.pbm","Pbm/Chibi.pbm","Pbm/Hoshi.pbm","Pbm/Dum.pbm","Pbm/Carry.pbm","Pbm/Juel.pbm","Pbm/Ufo.pbm"
        };
        //X and Y is the draw offset.
        public void Draw(int px,int py,double Time,IGraphicsDriver graphics)
        {
            if (Exists) {
                IImage npci=graphics.GetImage(NpcImg[Type], 0, 0, 0);
                int xx=0;
                int yy=0;
                int ww=16;
                int hh=16;
                int ox=0;
                int oy=0;
                if (Type==1)
                {
                xx=((int)OX)*16;
                }
                if (Type==3)
                {
                xx=0;
                yy=0;
                ox=-2;
                oy=-4;
                ww=npci.GetWidth()/2;
                hh=npci.GetHeight()/2;
                }
                if (Type==4)
                {
                xx=0;
                yy=0;
                ox=4;
                oy=4;
                ww=8;
                hh=8;
                }
                if (Type==6)
                {
                xx=((int)OX)*16;
                }
                if (Type==7)
                {
                xx=0;
                yy=0;
                ww=npci.GetWidth()/2;
                hh=npci.GetHeight()/2;
                ox=8-(ww/2);
                oy=8-(hh/2);
                }
                if (Type==9)
                {
                xx=0;
                yy=0;
                ww=npci.GetWidth();
                hh=npci.GetHeight();
                oy=-(hh/2);
                }
                
                if (npci==null)
                {
                System.out.println("BAD NPCTYPE "+Type);
                } else{
                graphics.BlitBCKImage(xx, yy, ww, hh, (int) (X * 16) + px + ox, (int) (Y * 16) + py + oy, npci);
                }
            }
        }
        public boolean StopsIkachan() {
            return (CollisionType == 3) || (CollisionType == 2);
        }
        //Called once per frame at most on collision with Ikachan.
        //Time is the current 'physical time'-essentially the amount of seconds not spent in a script.
        //This is used to avoid Ikachan continually activating the same script.
        public void HandleIkachanCollision(IEventCallback iec, double Time) {
            //TODO:Anything involving Ironhead.
            //TODO:HandleIkachanCollision for enemies.
            if (CollisionType == 0) {
                if (LastTimeIkachanAnnoyedMe + 1 <= Time) {
                    iec.StartEvent(EventID);
                    LastTimeIkachanAnnoyedMe = Time;
                }
            }
            if (CollisionType == 2) {
                
                //this is 'on death'
                //iec.StartEvent(EventID);
            }
            if (CollisionType == 3) {
                if (LastTimeIkachanAnnoyedMe + 1 <= Time) {
                    iec.StartEvent(EventID);
                    LastTimeIkachanAnnoyedMe = Time;
                }
            }
        }
    }
    //Note that there MAY be a problem with this.
    //Or the function below.
    //One hint:It involves the sign bit.
    //Not a major problem,but feel free to fix it if you know the 'right' value.
    private static void DoubleToFixedPoint(double d, FileOutputStream fos) throws IOException {
        int dd=(int)Math.floor(d);
        dd=dd<<14;
        double fractional=d-Math.floor(d);
        fractional*=1<<14;
        dd+=(int) fractional;
        fos.write((dd&0xFF));
        fos.write((dd&0xFF00)>>8);
        fos.write((dd&0xFF0000)>>16);
        fos.write((dd&0xFF000000)>>24);
    }

    private static double FixedPointToDouble(InputStream is) throws IOException {
        double fractional = is.read();
        int mb = is.read();//WWFFFFFF
        fractional += (mb & 0x3F) << 8;
        fractional /= (1 << 14);
        int whole = (mb & (64 | 128)) / 64;
        whole |= is.read() << 2;
        whole |= is.read() << 10;
        return fractional + whole;
    }

    
    public GameStateNPChar()
    {
        for (int p = 0; p < chars.length; p++) {
            chars[p]=new NPCCharacter();
        }
    }
    
    
    public void Load(InputStream is) throws Exception {
        for (int p = 0; p < chars.length; p++) {
            NPCCharacter nc = new NPCCharacter();
            boolean sw = is.read() != 0;
            nc.CollisionType = is.read();
            nc.Type = is.read();
            nc.EventID = is.read();
            nc.Status=is.read();//?
            nc.Status |= is.read() << 8;
            nc.X = FixedPointToDouble(is);
            nc.Y = FixedPointToDouble(is);
            nc.OX = FixedPointToDouble(is) - nc.X;//not 'supposed' to do this,but...
            nc.OY = FixedPointToDouble(is) - nc.Y;
            nc.Exists=sw;
            chars[p] = nc;
        }
    }
   
    public void Save(FileOutputStream fos) throws IOException {
        for (int p = 0; p < chars.length; p++) {
            NPCCharacter nc=chars[p];
            if (nc.Exists)
            { 
                fos.write(1);
            } else {
                fos.write(0);
            }
            fos.write(nc.CollisionType);
            fos.write(nc.Type);
            fos.write(nc.EventID);
            fos.write(nc.Status&0xFF);
            fos.write((nc.Status&0xFF00)>>8);
            DoubleToFixedPoint(nc.X,fos);
            DoubleToFixedPoint(nc.Y,fos);
            DoubleToFixedPoint(nc.X+nc.OX,fos);
            DoubleToFixedPoint(nc.Y+nc.OY,fos);
        }
    }

    public void Render(int px, int py, double Time,IGraphicsDriver gd) {
        //TODO:Finish NPChar Renderer
        for (int p = 0; p < chars.length; p++) {
            chars[p].Draw(px, py,Time,gd);
        }
    }
}
