/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan;

/**
 * A graphics driver.The idea is to speed up work on ports.
 * To run just the game,you only need to implement BASIC and INPUT-BASIC(only 4 keys needed)
 * To run the editor,you have to implement pretty much everything.
 * @author matt
 */
public interface IGraphicsDriver {
    public static final int VK_SWIM = 0;
    public static final int VK_ITEMS = 1;
    public static final int VK_UP = 2;
    public static final int VK_DOWN = 3;
    public static final int VK_LEFT = 4;
    public static final int VK_RIGHT = 5;

    //BASIC
    public static interface IImage {
        public int GetWidth();
        public int GetHeight();
    }
    public boolean StillRunning();
    public int GetWidth();
    public int GetHeight();
    public IImage GetImage(String a,int r,int g,int b);
    public void BlitImage(int srcx,int srcy,int srcw,int srch,int x,int y,IImage i);
    //Display 8 pixel high text in Monospace.
    public void Display8pxText(int x,int y,int r,int g,int b,String text);
    //used to mean 'black colour key' now means 'but colour key'
    public void BlitBCKImage(int srcx,int srcy,int srcw,int srch,int x,int y,IImage i);
    public void Clear(int i, int i0, int i1);
    public void Flush();//This copies the IsKeyDown buffer to WasKeyDown.
    //INPUT-BASIC
    public boolean IsKeyDown(int KEYID);
    public boolean IsKeyJustPressed(int KEYID);//Note that if this returns true,it won't return true again for any other call for that key until another press happens.
    //INPUT-ADVANCED
    //Note that these only apply when the mouse is down.
    public int GetMouseX();
    public int GetMouseY();
    public boolean GetMouseDown();
    public boolean GetMouseJustDown();//Note that if this returns true,it won't return true again for any other call until another press happens.
    public int GetMouseButton();//Get the Mouse button currently pressed. 0:None 1:Left,3:Right
    //if it's completely impossible to provide 320x240,or the player requests it,put the true values in and hope it works.
    //INPUT-NUMPAD
    public void UsingNumpad(boolean using);//For on-screen numpads
    public int GetNumpadNumber();
    public void SetNumpadNumber(int i);
}
