/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.blocks;

import javachan.GameState;
import javachan.IGraphicsDriver;
import javachan.Rect;
import javachan.GameStateMap;

/**
 * The root of all block types.
 * @author matt
 */
public class BasicBlockType {
    public int GetAmountOfSubTypes(IGraphicsDriver igd)
    {
        return igd.GetImage(GetBlockImage(), 0, 0, 0).GetWidth()/16;
    }
    protected String GetBlockImage()
    {
        return "Pbm/PrtBlock.pbm";
    }
    //Does colliding with this halt Ikachan?
    public boolean CollisionStops()
    {
        return true;
    }
    //Area of collision.
    public Rect GetCollision(int x,int y,int subtype)
    {
        return new Rect(x*16,y*16,16,16);
    }
    //Draws this block at a specific pixel position.Note that pass is 0 or 1(0 is back,1 is fore)
    public void Draw(int pass,int ox,int oy,int subtype,IGraphicsDriver igd,double Time)
    {
        if (pass!=0) return;
        igd.BlitBCKImage(16*subtype, 0, 16, 16, ox, oy, igd.GetImage(GetBlockImage(), 0, 0, 0));
    }
}
