/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games;

import java.io.FileOutputStream;
import java.util.logging.Level;
import java.util.logging.Logger;
import javachan.Game;
import javachan.GameState;
import javachan.GameStateNPChar;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IGame;
import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;
import javachan.Rect;
import javachan.blocks.DirectionBlockType;
import javachan.games.editorui.UIButton;
import javachan.games.editorui.UIElement;
import javachan.games.editorui.UINPCTypes;
import javachan.games.editorui.UINumberBox;
import javachan.games.editorui.UIPanel;
import javachan.games.editorui.UITileTypes;

/**
 * The tile editor. 
 * The object editor is in official Ikachan,but mine has a on-screen save button.
 * 
 * @author matt
 */

//Note the NPC editor layout is like this:
/*NPCW NPCTW    MPW
 * 64 | 216-NPCW | width-(NPCW+NPCTW)
 * ----------------------------------
 * 
 * and vertically:
 * MPH 32
 */

public class EditorGame implements IGame {

    public GameState gs;
    public int Tab = 0;
    //LEVEL 1 ELEMENTS
    public UIPanel NPCTab=new UIPanel(),TileTab=new UIPanel(),Common=new UIPanel();
    //LEVEL 2 ELEMENTS
    //common
    public UIButton SaveButton=new UIButton(),TabSwitch=new UIButton();
    //npc
    public UIPanel NumbersPanel=new UIPanel();
    public UINPCTypes NPCS=new UINPCTypes();
    //tiles
    public UINumberBox Tile_Number=new UINumberBox();
    public UITileTypes TILES=new UITileTypes();
    //LEVEL 3 ELEMENTS
    //npc
    public UIPanel NPC_CheckBox=new UIPanel();
    public UIButton NPC_CollisionType=new UIButton();
    public UINumberBox NPC_EventID=new UINumberBox(),NPC_NPCID=new UINumberBox(),NPC_X=new UINumberBox(),NPC_Y=new UINumberBox();
    //PX,PY:Camera position(as draw offset)
    public double PX = 0, PY = 0;
    //If 0 or under,then draw save normally,else draw it offset a bit so the user knows it saved
    public double SavePressTime = 0;

    public EditorGame(GameState ggs) {
        gs = ggs;
        NumbersPanel.SetBounds(new Rect(0,0,128,64));
        TILES.OnChange=new Runnable(){

            @Override
            public void run() {
                Tile_Number.Number=(TILES.SelectedType*16)+TILES.SelectedSubType;
            }
        };
        NPC_CheckBox.SetBounds(new Rect(2,10,16,8));
        NPC_CheckBox.ImageX=304;
        NPC_CollisionType.SetBounds(new Rect(40,34,48,14));
        NPC_CollisionType.OnClick=new Runnable() {

            @Override
            public void run() {
                gs.npcs.chars[NPC_NPCID.Number].CollisionType++;
                if (gs.npcs.chars[NPC_NPCID.Number].CollisionType>=4)
                    gs.npcs.chars[NPC_NPCID.Number].CollisionType=0;
            }
        };
        NPC_NPCID.SetBounds(new Rect(40,0,64,16));
        NPCS.OnChange=new Runnable() {

            @Override
            public void run() {
                gs.npcs.chars[NPC_NPCID.Number].Type=NPCS.SelectedType;
                gs.npcs.chars[NPC_NPCID.Number].OX=NPCS.SelectedSubType;
            }
        };
        NPC_NPCID.OnEdit=new Runnable() {

            @Override
            public void run() {
                if (NPC_NPCID.Number>=100) NPC_NPCID.Number=0;
                if (NPC_NPCID.Number<0) NPC_NPCID.Number=0;
                NPC_EventID.Number=gs.npcs.chars[NPC_NPCID.Number].EventID;
                NPC_X.Number=(int)gs.npcs.chars[NPC_NPCID.Number].X;
                NPC_Y.Number=(int)gs.npcs.chars[NPC_NPCID.Number].Y;
                NPCS.SelectedSubType=(int)gs.npcs.chars[NPC_NPCID.Number].OX;
                NPCS.SelectedType=gs.npcs.chars[NPC_NPCID.Number].Type;
            }
        };
        NPC_EventID.SetBounds(new Rect(40,16,64,16));
        NPC_EventID.OnEdit=new Runnable() {

            @Override
            public void run() {
                if (NPC_EventID.Number>=256) NPC_EventID.Number=0;
                if (NPC_EventID.Number<0) NPC_EventID.Number=0;
                gs.npcs.chars[NPC_NPCID.Number].EventID=NPC_EventID.Number;
            }
        };
        NPC_X.SetBounds(new Rect(28,50,64,16));
        NPC_X.OnEdit=new Runnable() {

            @Override
            public void run() {
                gs.npcs.chars[NPC_NPCID.Number].X=NPC_X.Number;
            }
        };
        NPC_Y.SetBounds(new Rect(94,50,64,16));
        NPC_Y.OnEdit=new Runnable() {

            @Override
            public void run() {
                gs.npcs.chars[NPC_NPCID.Number].Y=NPC_Y.Number;
            }
        };
        NPC_NPCID.OnEdit.run();

        NPCTab.Elements.add(Common);
        NPCTab.Elements.add(NumbersPanel);
        NPCTab.Elements.add(NPCS);
        NumbersPanel.Elements.add(NPC_EventID);
        NumbersPanel.Elements.add(NPC_NPCID);
        NumbersPanel.Elements.add(NPC_X);
        NumbersPanel.Elements.add(NPC_Y);
        NumbersPanel.Elements.add(NPC_CheckBox);
        NumbersPanel.Elements.add(NPC_CollisionType);

        TileTab.Elements.add(Common);
        TILES.Elements.add(Tile_Number);
        TileTab.Elements.add(TILES);
        SaveButton.SetBounds(new Rect(0,0,32,32));
        SaveButton.OnClick=new Runnable()
                {

            @Override
            public void run() {
                try {
                    FileOutputStream fos=new FileOutputStream("Pbm/Map1.pbm");
                    gs.map.SaveBitmap(fos);
                    fos.close();
                    fos=new FileOutputStream("NPChar.dat");
                    gs.npcs.Save(fos);
                    fos.close();
                } catch (Exception e)
                {
                }
            }
                };
                TabSwitch.OnClick=new Runnable()
                {

            @Override
            public void run() {
                Tab^=1;
            }
                };

        TabSwitch.SetBounds(new Rect(32,0,64,32));
        Common.Elements.add(SaveButton);
        Common.Elements.add(TabSwitch);
        TILES.BlockTypes=gs.map.blocktypes;
    }
    @Override
    public void Run(double DeltaTime, double Time, Game g) {
        //---------------------------------START MY LAYOUT CODE
        Common.SetBounds(new Rect(g.graphics.GetWidth()-96,0,96,64));
        NPCTab.SetBounds(new Rect(0,0,g.graphics.GetWidth(),64));
        TileTab.SetBounds(new Rect(0,0,g.graphics.GetWidth(),64));
        Tile_Number.SetBounds(new Rect(TileTab.GetBounds().width-64,TileTab.GetBounds().height-16,64,16));
        //128(NumbersPanel Size)+96(Common Size)
        NPCS.SetBounds(new Rect(128,0,g.graphics.GetWidth()-(128+96),64));
        //96(Common Size)
        TILES.SetBounds(new Rect(0,0,g.graphics.GetWidth()-96,64));
        IImage edit = g.graphics.GetImage("TileEditor.png", 0, 0, 0);
        NPC_CollisionType.Image=NPC_CheckBox.Image=NumbersPanel.Image=TabSwitch.Image=SaveButton.Image=edit;
        NPC_CollisionType.ImageX=448;
        NPC_CollisionType.ImageY=(gs.npcs.chars[NPC_NPCID.Number].CollisionType*16)+2;
        NumbersPanel.ImageX=320;
        
        if (gs.npcs.chars[NPC_NPCID.Number].Exists)
        {
        NPC_CheckBox.ImageY=0;
        } else {
        NPC_CheckBox.ImageY=8;
        }
        TabSwitch.ImageX=32+(64*Tab);
        //--------------------------------END MY LAYOUT CODE
        g.graphics.Clear(0, 0, 0);
        int cmx = g.graphics.GetMouseX();
        int cmy = g.graphics.GetMouseY();
        int cmb = g.graphics.GetMouseButton();
        int Mx = (int) Math.floor((cmx - PX) / 16);//in !tiles!
        int My = (int) Math.floor((cmy - PY) / 16);//in !tiles!
            if (g.graphics.GetMouseJustDown())
            {
                if (cmy<64)
                {
                if (Tab==0)
                {
                g.graphics.SetNumpadNumber(NPCTab.HandleClick(cmx, cmy));
                } else {
                g.graphics.SetNumpadNumber(TileTab.HandleClick(cmx, cmy));
                }
                } else {
                if (Tab==0)
                {
                    if (cmb==1)
                    {
                gs.npcs.chars[NPC_NPCID.Number].X=Mx;
                gs.npcs.chars[NPC_NPCID.Number].Y=My;
                gs.npcs.chars[NPC_NPCID.Number].Exists=true;
                    } 
                    if (cmb==3)
                    {
                gs.npcs.chars[NPC_NPCID.Number].Exists=false;
                    }
                } else {
                    if (cmb==1)
                    {
                    if (Mx>=0)
                        if (My>=0)
                            if (Mx<gs.map.Width)
                                if (My<gs.map.Height)
                                    gs.map.data[Mx+(My*gs.map.Width)]=Tile_Number.Number;
                    } else {
                    if (Mx>=0)
                        if (My>=0)
                            if (Mx<gs.map.Width)
                                if (My<gs.map.Height)
                                    gs.map.data[Mx+(My*gs.map.Width)]=0;
                    }
                }
                }
            }
            if (g.graphics.GetMouseDown())
            {
                if (cmy<64)
                {
                    if (cmb==1)
                    {
                if (Tab==0)
                {
                NPCTab.HandleDrag(cmx, cmy);
                } else {
                TileTab.HandleDrag(cmx, cmy);
                }
                    }
                } else {
                if (Tab==0)
                {
                } else {
                }
                }
            }
        if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_SWIM))
        {
            if (Tab==0)
            {
                for (int p=0;p<gs.npcs.chars.length;p++)
                {
                    NPCCharacter npcc=gs.npcs.chars[p];
                    if (npcc.Exists)
                    if (new Rect(Mx*16,My*16,16,16).intersects(new Rect((int)(npcc.X*16),(int)(npcc.Y*16),16,16)))
                    {
                        NPC_NPCID.Number=p;
                        NumbersPanel.Selected=null;
                        NPC_NPCID.OnEdit.run();
                        break;
                    }
                }
            }
        }
        if (g.graphics.IsKeyDown(IGraphicsDriver.VK_DOWN)) {
            PY -= DeltaTime * 256;
        }
        if (g.graphics.IsKeyDown(IGraphicsDriver.VK_UP)) {
            PY += DeltaTime * 256;
        }
        if (g.graphics.IsKeyDown(IGraphicsDriver.VK_LEFT)) {
            PX += DeltaTime * 256;
        }
        if (g.graphics.IsKeyDown(IGraphicsDriver.VK_RIGHT)) {
            PX -= DeltaTime * 256;
        }
        gs.RenderBack((int) PX, (int) PY, Time, g.graphics);
        gs.map.RenderTiles((int) PX, (int) PY, 0, Time, g.graphics);
        for (int xx=-1;xx<gs.map.Width+1;xx++)
        {
        for (int yy=-1;yy<gs.map.Height+1;yy++)
        {
        if (new Rect(0,0,gs.map.Width,gs.map.Height).contains(xx, yy))
            continue;
        g.graphics.BlitImage(222, 0, 16, 16, ((xx * 16) + ((int) PX)), ((yy * 16) + ((int) PY)), edit);
        }
        }
        gs.npcs.Render((int) PX, (int) PY, Time, g.graphics);
        gs.RenderPC((int) PX, (int) PY, 0, g.graphics);
        gs.map.RenderTiles((int) PX, (int) PY, 1, Time, g.graphics);
        g.graphics.BlitBCKImage(0, 32, 16, 16, ((Mx * 16) + ((int) PX)), ((My * 16) + ((int) PY)), edit);
        if (Tab==0)
        g.graphics.BlitBCKImage(32, 16, 16, 16, (int)(gs.npcs.chars[NPC_NPCID.Number].X*16)+(int)PX,(int)(gs.npcs.chars[NPC_NPCID.Number].Y*16)+(int)PY, g.graphics.GetImage("Pbm/Cursor.pbm", 0,0,0));
        DisplayNumber(Mx, 0, g.graphics.GetHeight() - 16, g.graphics,edit);
        DisplayNumber(My, 64, g.graphics.GetHeight() - 16, g.graphics,edit);
        for (int px=0;px<g.graphics.GetWidth();px+=32)
        {
            g.graphics.BlitImage(222, 0, 32, 32, px, 0, edit);
            g.graphics.BlitImage(222, 0, 32, 32, px, 32, edit);
        }
        if (Tab==0)
        {
                for (int p=0;p<gs.npcs.chars.length;p++)
                {
                    NPCCharacter npcc=gs.npcs.chars[p];
                    if (npcc.Exists)
                    g.graphics.BlitBCKImage(0, 32, 16,16, (int)(npcc.X*16)+((int)PX), (int)(npcc.Y*16)+((int)PY), edit);
                    
                }
            TileTab.Selected=null;
            NPCTab.UpdateAndDraw(0,0, DeltaTime, true, g.graphics);
        } else {
            NPCTab.Selected=null;
            TileTab.UpdateAndDraw(0,0, DeltaTime, true, g.graphics);
        }
        g.graphics.Flush();
    }

    public static void DisplayNumber(int NPC_NO, int i, int i0, IGraphicsDriver graphics,IImage edit) {
        String ss = "" + NPC_NO;
        int pp = 0;
        for (char c : ss.toCharArray()) {
            graphics.BlitImage((c - '0') * 8, 48, 8, 16, i + pp, i0,edit);
            pp += 9;
        }
    }
}
