/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javachan.Game;
import javachan.GameState;
import javachan.IEventCallback;
import javachan.IGame;
import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;
import javachan.GameStateMap;
import javachan.IPhysicsEngine;

/**
 *
 * @author matt
 */
public class MainGame implements IGame,IEventCallback {
    
    public GameState gs=new GameState();
    public int ScriptPoint;
    public String CurrentChat=null;
    public int CurrentChatReveal=0;
    public boolean ShowMap=false;
    public double InGameTime=0;
    public double FadeTimer=0;//Fades apparently don't pause the script.
    public int FadeState=0;
    public int SavedLR=0;//used for displaying Ikachan
    public IPhysicsEngine physics;
    //SCRIPT STATE VARIABLES
    public int MajorState=0;//0:Startup,1:Main Game
                            //All except MinorState 0 mean paused.
    public int MinorState=0;//0:None,1:Pause Script For Chat,2:Pause Script For (Yes) No,3:Pause Script For Yes (No),4:Pause Script For Transient Chat
    public int YesDest=0;//Y/N
    public double GeneralMinorUseTimer=0;//for minors
    public int EntityCount=0;// A variable only used once in the entire game.
    //END SCRIPT STATE VARIABLES
    public boolean RunScriptCommand(double Delta,Game g)
    {
        String s=GetLine(ScriptPoint++);
        if (s.startsWith("<"))
        {
            //COMMANDS
            if (s.startsWith("<yn"))
            {
                YesDest=LookupEvent(ParseInt(s.substring(3)))+1;
                MinorState=2;
                return false;
            }
            if (s.startsWith("<pd"))
            {
                String r="Pmd/Tidepool.pmd";
                int i=ParseInt(s.substring(3));
                if (i==0)
                {
                    r="Pmd/Ikachan.pmd";
                }
                if (i==1)
                {
                    r="Pmd/Magirete.pmd";
                }
                if (i==2)
                {
                    r="Pmd/Buriki.pmd";
                }
                if (i==3)
                {
                    r="Pmd/Mizuno.pmd";
                }
                if (i==4)
                {
                    r="Pmd/Quake.pmd";
                }
                g.music.SetMusic(r);
                return true;
            }
            if (s.startsWith("<pp"))
            {
                g.music.PlayMusic();
                return true;
            }
            if (s.startsWith("<ps"))
            {
                g.music.StopMusic();
                return true;
            }
            if (s.startsWith("<fi"))
            {
                FadeState=1;
                FadeTimer=0;
                return true;
            }
            if (s.startsWith("<fo"))
            {
                FadeState=2;
                FadeTimer=0;
                return true;
            }
            if (s.startsWith("<ec"))
            {
                EntityCount++;
                return true;
            }
            if (s.startsWith("<fj"))
            {
                if (gs.Flags[ParseInt(s.substring(3))])
                    ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                return true;
            }
            if (s.startsWith("<ij"))
            {
                int pi=ParseInt(s.substring(3));
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==pi)
                        ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                }
                return true;
            }
            if (s.startsWith("<ej"))
            {
                if (ParseInt(s.substring(3))==EntityCount)
                    ScriptPoint=LookupEvent(ParseInt(s.substring(8)))+1;
                return true;
            }
            if (s.startsWith("<nm"))
            {
                ShowMap=true;
                return true;
            }
            if (s.startsWith("<ma"))
            {
                ShowMap=false;
                return true;
            }
            if (s.startsWith("<i+"))
            {
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==0)
                    gs.Items[xx]=ParseInt(s.substring(3));
                }
                return true;
            }
            if (s.startsWith("<i-"))
            {
                int pi=ParseInt(s.substring(3));
                for (int xx=0;xx<gs.Items.length;xx++)
                {
                    if (gs.Items[xx]==pi)
                    gs.Items[xx]=0;
                }
                return true;
            }
            if (s.startsWith("<f+"))
            {
                gs.Flags[ParseInt(s.substring(3))]=true;
                return true;
            }
            if (s.startsWith("<cm"))
            {
                int npcc=ParseInt(s.substring(3));
                int npcx=ParseInt(s.substring(3+5));
                int npcy=ParseInt(s.substring(3+5+5));
                gs.npcs.chars[npcc].X=npcx;
                gs.npcs.chars[npcc].Y=npcy;
                if (npcx==0)
                if (npcy==0)
                    gs.npcs.chars[npcc].Exists=false;
                return true;
            }
            if (s.startsWith("<pc"))
            {
                int pca=ParseInt(s.substring(3));
                int pcb=ParseInt(s.substring(3+5));
                int pcc=ParseInt(s.substring(3+5+5));
                System.out.println("pca"+pca+"-pcb"+pcb+"-pcc"+pcc);
                gs.map.data[pca+(pcb*gs.map.Width)]=pcc;
                return true;
            }
            if (s.startsWith("<end"))
            {
                if (MajorState==0)
                {
                    MajorState=1;
                    ScriptPoint=LookupEvent(2)+1;
                    if (g.graphics.IsKeyDown(IGraphicsDriver.VK_ITEMS))
                    {
                        g.gamestate=new EditorGame(gs);
                    } else {
                        //TODO:MaruAme,annoying as it is
                        //---NOTE:This is for the forum release,so hide the incomplete stuff---
                        g.gamestate=new EditorGame(gs);
                    }
                    g.music.StopMusic();
                    g.music.SetMusic("Pmd/Ikachan.pmd");
                } else {
                ScriptPoint=-1;
                }
                return false;
            }
            System.out.println("NYI:"+s);
            return true;
        } else {
            while (s.endsWith("+"))
            {
                s=s.substring(0,s.length()-1);
                s+="\r\n";
                s+=GetLine(ScriptPoint++);
            }
            if (s.endsWith("/"))
            {
                s=s.substring(0,s.length()-1);
            MinorState=1;
            } else {
            MinorState=4;
            }
            GeneralMinorUseTimer=0;
            CurrentChat=s;
            CurrentChatReveal=0;
            return false;//needs to get on the screen :)
        }
    }
    public MainGame()
    {
        StartEvent(1);
        try {
            gs.map.LoadBitmap(new FileInputStream("Pbm/Map1.pbm"));
            gs.npcs.Load(new FileInputStream("NPChar.dat"));
        } catch (Exception ex) {
            Logger.getLogger(MainGame.class.getName()).log(Level.SEVERE, "Couldn't load main map!!!", ex);
        }
    }
    //This function is structured so the JustPress functions do only get called once.
    //Just look carefully at the code paths...(really really carefully!)
    @Override
    public void Run(double DeltaTime, double Time, Game g) {
        g.graphics.UsingNumpad(false);
        //--------------------------UPDATE
        if (MinorState==0)
        {
        if (ScriptPoint!=-1)
        {
            //Run until signal given 'done for this frame'
            while (RunScriptCommand(DeltaTime,g)) {}
        }
        }
        //now,after that is done,re-test
        if (ScriptPoint==-1)
        {
            CurrentChat=null;//done with chat,no script running==no chat!
            //PHYSICS
            InGameTime+=DeltaTime;
            int LR=0;
            if (g.graphics.IsKeyDown(IGraphicsDriver.VK_ITEMS)) LR=-1;
            physics.Update(InGameTime,LR,g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_SWIM),(IEventCallback)this,gs);
            SavedLR=LR;
        }
        
        //--------------------------DRAWING
        
        g.graphics.Clear(0,0,0);
        //draw map here,ikachan included at no extra cost.
        //RENDERING.Call in this order:RenderBack,Map.Render(pass 0),NPChar.Render,RenderPC,Map.Render(pass 1)
        int CamX=(int)-((gs.PlayerX*16)-(g.graphics.GetWidth()/2));
        int CamY=(int)-((gs.PlayerY*16)-(g.graphics.GetHeight()/2));
        if (ShowMap)
        {
            gs.RenderBack(CamX,CamY, Time, g.graphics);
                gs.map.RenderTiles(CamX,CamY, 0, Time, g.graphics);
                    gs.npcs.Render(CamX, CamY, Time, g.graphics);
                    gs.RenderPC(CamX, CamY, SavedLR, g.graphics);
                gs.map.RenderTiles(CamX,CamY, 1, Time, g.graphics);
        }
        if (CurrentChat!=null)
        {
            IImage chatbox=g.graphics.GetImage("Pbm/Msgbox.pbm", 0,0,0);
            g.graphics.BlitBCKImage(0, 0, chatbox.GetWidth(), chatbox.GetHeight(), 10, g.graphics.GetHeight()-(chatbox.GetHeight()+9), chatbox);
            g.graphics.Display8pxText(20, (g.graphics.GetHeight()+2)-(chatbox.GetHeight()-(8-9)), 0, 0, 255, CurrentChat.substring(0, CurrentChatReveal));
            g.graphics.Display8pxText(18, g.graphics.GetHeight()-(chatbox.GetHeight()-(8-9)), 255, 255, 255, CurrentChat.substring(0, CurrentChatReveal));
        }
        //---------------------------MINOR STATE HANDLERS--------------------------------
        //both update and drawing.
        double ChatSpeed=15;
        if (MinorState==1)
        {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            if (g.graphics.IsKeyDown(IGraphicsDriver.VK_SWIM))
            {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            }
            CurrentChatReveal=(int)GeneralMinorUseTimer;
            if (GeneralMinorUseTimer>CurrentChat.length())
            {
                IImage tinyguy=g.graphics.GetImage("Pbm/Cursor.pbm", 0,0,0);//cute star thing.
                int frame=((int)(Time*10))%6;
                g.graphics.BlitBCKImage(48+((frame>3)?((frame-2)*8):(frame*8)), (frame>3)?0:16, 8, 16, 295, g.graphics.GetHeight()-27, tinyguy);
                CurrentChatReveal=CurrentChat.length();
            if (g.graphics.IsKeyDown(IGraphicsDriver.VK_SWIM))
            {
                MinorState=0;
            }
            }
        }
        if (MinorState==2)
        {
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_LEFT))
            {
                //L
                MinorState=2;
            }
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_RIGHT))
            {
                //R
                MinorState=3;
            }
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_SWIM))
            {
                MinorState=0;
                ScriptPoint=YesDest;
            }
            DrawYN(g.graphics,true);
        }
        if (MinorState==3)
        {
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_LEFT))
            {
                //L
                MinorState=2;
            }
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_RIGHT))
            {
                //R
                MinorState=3;
            }
            if (g.graphics.IsKeyJustPressed(IGraphicsDriver.VK_SWIM))
            {
                MinorState=0;
            }
            DrawYN(g.graphics,false);
        }
        if (MinorState==4)
        {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            if (g.graphics.IsKeyDown(IGraphicsDriver.VK_SWIM))
            {
            GeneralMinorUseTimer+=DeltaTime*ChatSpeed;
            }
            CurrentChatReveal=(int)GeneralMinorUseTimer;
            if (CurrentChatReveal>CurrentChat.length())
            {
                CurrentChatReveal=CurrentChat.length();
                MinorState=0;
            }
        }
        //---------------------FADES(GOES ON TOP OF EVERYTHING ELSE)
        if (FadeState==1)
        {
            FadeTimer+=DeltaTime*32;
            if (FadeDrawer((int)FadeTimer,false,g.graphics)) FadeState=0;
        }
        if (FadeState==2)
        {
            FadeTimer+=DeltaTime*32;
            if (FadeDrawer((int)FadeTimer,true,g.graphics)) FadeState=0;
        }
        g.graphics.Flush();
    }
    //lines start at 1.
    private String GetLine(int line)
    {
        try {
            BufferedReader br = new BufferedReader(new FileReader("Event.ptx"));
            String s="";
            while (line>0) {line--; s=br.readLine();}
            br.close();
            return s;
        } catch (Exception ex) {
            Logger.getLogger(MainGame.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
    private int LookupEvent(int i) {
        int Line=1;
        while (true)
        {
            
            String s=GetLine(Line);
            if (s.startsWith("#e"))
                if (ParseInt(s.substring(2,6))==i)
                {
                    return Line;
                }
            Line++;
        }
    }

    private int ParseInt(String substring) {
        int A=substring.charAt(3)-'0';
        int B=substring.charAt(2)-'0';
        int C=substring.charAt(1)-'0';
        int D=substring.charAt(0)-'0';
        C+=D*10;
        B+=C*10;
        A+=B*10;
        return A;
    }

    private void DrawYN(IGraphicsDriver graphics, boolean b) {
            IImage yesno=graphics.GetImage("Pbm/YesNo.pbm", 0,0,0);
            //offset for yesno signs from backings
            int ox=9;
            int oy=7;
            //offset for yesno backings from top left of screen
            int xx=0;
            int yy=0;
            xx=((graphics.GetWidth()/2)-16)-(yesno.GetWidth()-48);
            yy=(graphics.GetHeight()/2)-yesno.GetHeight();
            if (b)
            {
            graphics.BlitBCKImage(48, 0, yesno.GetWidth()-48, yesno.GetHeight(), xx,yy, yesno);
            }
            graphics.BlitBCKImage(0, 0, 48, yesno.GetHeight()/2, xx+ox,yy+oy, yesno);
            xx=((graphics.GetWidth()/2)+16);
            if (!b)
            {
            graphics.BlitBCKImage(48, 0, yesno.GetWidth()-48, yesno.GetHeight(), xx, yy, yesno);
            }
            graphics.BlitBCKImage(0, yesno.GetHeight()/2, 48, yesno.GetHeight()/2, xx+ox,yy+oy, yesno);
    }

    @Override
    public void StartEvent(int ev) {
        ScriptPoint=LookupEvent(ev)+1;
    }
    //This is a static routine because it's technically global-fade out is done by Opening 
    //before we switch gamestates and do the fade in.
    public static boolean FadeDrawer(int stage,boolean out,IGraphicsDriver to)
    {
        IImage fade=to.GetImage("Pbm/Fade.pbm", 0, 0, out?0:16);
        boolean ended=true;
        for (int x=0;x<to.GetWidth();x+=16)
        for (int y=0;y<to.GetHeight();y+=16)
        {
            int lstage=stage;
            int dy=to.GetHeight()-y;
            int dx=to.GetWidth()-x;
            int p=(dy/16)+(x/16);
            lstage-=p;
            if (lstage<0) {lstage=0;}
            if (lstage>15) {lstage=15;} else {ended=false;}
        to.BlitBCKImage(lstage*16, 0, 16, 16, x, y, fade);
        }
        return ended;
    }
}
