/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import java.util.LinkedList;
import javachan.IGraphicsDriver;
import javachan.IGraphicsDriver.IImage;
import javachan.Rect;

/**
 *
 * @author matt
 */
public class UIPanel extends UIElement {
    public IImage Image;
    public int ImageX,ImageY;
    public UIElement Selected;
    public LinkedList<UIElement> Elements=new LinkedList<UIElement>();

    //ox,oy specify where this element is being drawn.the bounds are used in calculating this.
    //the root panel gets a ox,oy of 0,0,for obvious reasons.
    @Override
    public void UpdateAndDraw(int ox, int oy,double DeltaTime,boolean select,IGraphicsDriver igd) {
        if (Image!=null)
            igd.BlitImage(ImageX, ImageY, Bounds.width, Bounds.height, ox,oy, Image);
        for (UIElement uie : Elements)
        {
            Rect r=uie.GetBounds();
            uie.UpdateAndDraw(ox+r.x, oy+r.y,DeltaTime,(Selected==uie)&&select, igd);
        }
    }
    //The click is within the (0,0,my width,my height) range.
    @Override
    public int HandleClick(int x, int y) {
        Selected=null;
        for (UIElement uie : Elements)
        {
                Rect r=uie.GetBounds();
            if (r.contains(x, y))
            {
                Selected=uie;//Note that it's important Selected is given to the element returning a numpad value.
                return uie.HandleClick(x-r.x, y-r.y);
            }
        }
        return 0;//caught by the panel???
    }
    @Override
    public void HandleDrag(int x, int y) {
        for (UIElement uie : Elements)
        {
                Rect r=uie.GetBounds();
            if (r.contains(x, y))
            {
                uie.HandleDrag(x-r.x, y-r.y);
                return;
            }
        }
    }

}
