/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package javachan.games.editorui;

import java.util.LinkedList;
import javachan.GameStateNPChar.NPCCharacter;
import javachan.IGraphicsDriver;
import javachan.Rect;
import javachan.blocks.BasicBlockType;
import javachan.blocks.DirectionBlockType;

/**
 *
 * @author matt
 */
public class UITileTypes extends UIPanel {
    public int SelectedType=0;
    public int SelectedSubType=0;
    public double Time=0;
    public Runnable OnChange;
    public BasicBlockType[] BlockTypes;
    public UITileTypes()
    {
        super();
        Elements.add(SCROLLBAR);
    }
    public UIScrollbar SCROLLBAR=new UIScrollbar();
    public int ScrollbarScale=4;
    public int[] Types=null;
    public int[] SubTypes=null;
    //Types that have no subtypes(and thus subtype should be ignored)
    public boolean[] SubTypeLess= {true,false,false,false,false,false,false,false,false,false,false,false,false,false,false,false};
    @Override
    public void UpdateAndDraw(int ox, int oy, double DeltaTime, boolean selected, IGraphicsDriver igd) {
        Time+=DeltaTime;
        if (Types==null) RebuildTypelist(igd);
        //UINPCTYPES LAYOUT CODE
        int roomneeded=Types.length;
        roomneeded-=(Bounds.width/32);
        if (roomneeded<0) roomneeded=0;
        SCROLLBAR.SetBounds(new Rect(0,0,(roomneeded*ScrollbarScale)+16,16));
        //--END UINPCTYPES LAYOUT CODE
        super.UpdateAndDraw(ox, oy, DeltaTime, selected, igd);
        for (int p=0;p<Bounds.width/32;p++)
        {
            int i=p+(SCROLLBAR.Value/ScrollbarScale);
            if (i>=Types.length) break;
            if (i<0) continue;
            int ooy=0;
            BasicBlockType bbt=BlockTypes[Types[i]];
            if (SelectedType==Types[i])
            {
            if ((SelectedSubType==SubTypes[i])||(SubTypeLess[SelectedType]))
            {
                ooy=8;
            }
            }
            if (bbt!=null)
            {
            igd.BlitImage(160+(Types[i]*8), 48, 16, 16,ox+8+(32*p), oy+ooy+16, igd.GetImage("TileEditor.png", 0, 0, 0));
            if (bbt instanceof DirectionBlockType)
            {
            igd.BlitImage(16+(16*SubTypes[i]), 32, 16, 16,ox+8+(32*p), oy+ooy+32, igd.GetImage("TileEditor.png", 0, 0, 0));
            }
            bbt.Draw(0,ox+8+(32*p), oy+ooy+32,SubTypes[i], igd,Time);
            bbt.Draw(1,ox+8+(32*p), oy+ooy+32,SubTypes[i], igd,Time);
            } else {
            igd.BlitImage(0, 32, 16, 16,ox+8+(32*p), oy+ooy+32, igd.GetImage("TileEditor.png", 0, 0, 0));
            }
        }
    }
    @Override
    public int HandleClick(int x, int y) {
        if (y>16)
        {
            int i=(x/32)+(SCROLLBAR.Value/ScrollbarScale);
            if (i<0)
                return 0;
            if (i>=Types.length)
                return 0;
            SelectedType=Types[i];
            SelectedSubType=SubTypes[i];
            if (OnChange!=null)
            OnChange.run();
            return 0;
        }
    return super.HandleClick(x,y);
    }

    public void RebuildTypelist(IGraphicsDriver igd) {
        LinkedList<Integer> lTypes=new LinkedList<Integer>();
        LinkedList<Integer> lSubTypes=new LinkedList<Integer>();
        lTypes.add(0);
        lSubTypes.add(0);
        int[] SubtypeCount={1,0,4,0,1,0,4,0,8,0,2,0,0,0,1,0};
        for (int bt=0;bt<16;bt++)
        {
            if (BlockTypes[bt]!=null)
            for (int i=0;i<SubtypeCount[bt];i++)
            {
            lTypes.add(bt);
            lSubTypes.add(i);
            }
        }
        Types=new int[lTypes.size()];
        for (int p=0;p<Types.length;p++)
            Types[p]=lTypes.get(p);
        SubTypes=new int[lSubTypes.size()];
        for (int p=0;p<Types.length;p++)
            SubTypes[p]=lSubTypes.get(p);
        
    }

}
